# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from hrpsys_gazebo_msgs/LIPSwitchFootCommand.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class LIPSwitchFootCommand(genpy.Message):
  _md5sum = "bb4dbe53a10574d4addaf1293a624e36"
  _type = "hrpsys_gazebo_msgs/LIPSwitchFootCommand"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header

# foot position command
# foot orientation is always same in the world coordinate.
geometry_msgs/Vector3 foot_position

# velocity command of mass link
geometry_msgs/Vector3 mass_velocity

# keep the current velocity if true
bool keep_mass_velocity

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['header','foot_position','mass_velocity','keep_mass_velocity']
  _slot_types = ['std_msgs/Header','geometry_msgs/Vector3','geometry_msgs/Vector3','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,foot_position,mass_velocity,keep_mass_velocity

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LIPSwitchFootCommand, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.foot_position is None:
        self.foot_position = geometry_msgs.msg.Vector3()
      if self.mass_velocity is None:
        self.mass_velocity = geometry_msgs.msg.Vector3()
      if self.keep_mass_velocity is None:
        self.keep_mass_velocity = False
    else:
      self.header = std_msgs.msg.Header()
      self.foot_position = geometry_msgs.msg.Vector3()
      self.mass_velocity = geometry_msgs.msg.Vector3()
      self.keep_mass_velocity = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_6dB.pack(_x.foot_position.x, _x.foot_position.y, _x.foot_position.z, _x.mass_velocity.x, _x.mass_velocity.y, _x.mass_velocity.z, _x.keep_mass_velocity))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.foot_position is None:
        self.foot_position = geometry_msgs.msg.Vector3()
      if self.mass_velocity is None:
        self.mass_velocity = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 49
      (_x.foot_position.x, _x.foot_position.y, _x.foot_position.z, _x.mass_velocity.x, _x.mass_velocity.y, _x.mass_velocity.z, _x.keep_mass_velocity,) = _struct_6dB.unpack(str[start:end])
      self.keep_mass_velocity = bool(self.keep_mass_velocity)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_6dB.pack(_x.foot_position.x, _x.foot_position.y, _x.foot_position.z, _x.mass_velocity.x, _x.mass_velocity.y, _x.mass_velocity.z, _x.keep_mass_velocity))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.foot_position is None:
        self.foot_position = geometry_msgs.msg.Vector3()
      if self.mass_velocity is None:
        self.mass_velocity = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 49
      (_x.foot_position.x, _x.foot_position.y, _x.foot_position.z, _x.mass_velocity.x, _x.mass_velocity.y, _x.mass_velocity.z, _x.keep_mass_velocity,) = _struct_6dB.unpack(str[start:end])
      self.keep_mass_velocity = bool(self.keep_mass_velocity)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_6dB = struct.Struct("<6dB")
